#include "eureka.h"


extern int children[16][MAXOPS];


bfs(BFS, numnodes, puzzle, goal, initial_threshold)
   List *BFS;
   int numnodes, puzzle[], goal[], *initial_threshold;
{
   int i, j, b, move, f_val;
   Node node, child;

   BFS = MakeEmptyList(BFS);        /* Generate BFS list containing root node */
   for (i=0; i<16; i++)
      node.puzzle[i] = puzzle[i];
   node.parent = -1;
   for (i=0; i<MAXOPS; i++)
      node.child_expanded[i] = 0;
   node.level = 0;
   node.h = *initial_threshold = state_cost(node.puzzle, goal);
   for (i=0; i<MAX_DEPTH; i++)
      node.path[i] = -1;
   node.cum_heuristic_error = node.number_children = 0;
   Insert(node, BFS);

   /* keep generating children until number of nodes >= number of processsors */
   while (ListSize(BFS) < numnodes) {
      node = RemoveLast(BFS);
      b = 0;                                   /* find location of blank cell */
      while (node.puzzle[b] != 0)
         b++;

      for (i=0; i<MAXOPS; i++) {                         /* generate children */
         move = children[b][oporder[i]];
         if ((move != -1) && (move != node.parent)) {
	    for (j=0; j<16; j++)
	       child.puzzle[j] = node.puzzle[j];
            child.puzzle[b] = child.puzzle[move];
            child.puzzle[move] = 0;
            child.parent = b;
	    for (j=0; j<MAXOPS; j++)
	       child.child_expanded[j] = 0;
            child.level = node.level + 1;
	    for (j=0; j<MAX_DEPTH; j++)
	       child.path[j] = node.path[j];
            child.path[child.level-1] = oporder[i];
            child.h = state_cost(child.puzzle, goal);
	    child.cum_heuristic_error = child.number_children = 0;
            f_val = child.level + child.h;
            if (f_val < *initial_threshold)
               *initial_threshold = f_val;
            Insert(child, BFS);
         }
      }
   }
   fprintf(stderr, "DTS generated %3d nodes\n", ListSize(BFS));
   fprintf(stderr, "initial threshold = %3d\n", *initial_threshold);
}
