#include "eureka.h"

extern int children[16][MAXOPS];

int dfs1(neighbors)
   int neighbors[];
{
   Node node, child_node;
   int i, b, mi, len, move, flag, f_val, heuristic_error;

   while (!EmptyList(OPEN)) {
      rc = pvm_probe(-1, -1);                           /* check for messages */
      if (rc) {
         rc = pvm_bufinfo(rc, &len, &type, &source);
	 message = parse_message(type, source);
      }

      if (ListSize(OPEN) < anticipatory)    /* if list is too small, get work */
	 get_work(2);

      node = RemoveFirst(OPEN);                   /* get parent node off list */

       /* move is based on where the blank is (b) and which move to make next */
      b = 0;                                   /* find location of blank cell */
      while (node.puzzle[b] != 0)
	 b++;
      flag = 0;

                          /* find first child node that has not been expanded */
      for (mi=0; mi<MAXOPS && flag == 0; mi++) {
	 move = children[b][oporder[mi]];
	 if (node.child_expanded[mi] == 0 && move != node.parent && move != -1)
	    flag = 1;
      }
      mi--;


             /* if an ungenerated child exists, then generate that child node */
      if (flag == 1) {
         if (node.number_children == 0)
            parents++;
	 total_nodes++;
	 node.path[node.level] = oporder[mi];
	 for (i=0; i<16; i++)
	    child_node.puzzle[i] = node.puzzle[i];
	 child_node.puzzle[b] = child_node.puzzle[move];    /* apply operator */
	 child_node.puzzle[move] = 0;
	 child_node.parent = b;
	 child_node.level = node.level + 1;
	 child_node.number_children = 0;
	 child_node.h = state_cost(child_node.puzzle, goal);

	      /* calculate difference between root estimate and estimate here */
	 heuristic_error = child_node.h - (root_heuristic - child_node.level);
	 child_node.cum_heuristic_error =
	    node.cum_heuristic_error + heuristic_error;
	                         /* if this is the goal, send message to host */
	 if (child_node.h == 0 && child_node.level < goal_level)
	    goal_found(child_node);
	 f_val = child_node.level + child_node.h;

	            /* set flag indicating that this child has been generated */
	 node.child_expanded[mi] = 1;

	               /* count the number of children generated by this node */
	 if (f_val <= threshold)
	    node.number_children++;
	     /* put parent back on the list if there are ungenerated children */
	 Insert(node, OPEN);

	                  /* if threshold not exceeded put child node on list */
	 if (f_val <= threshold) {
	    for (i=0; i<MAX_DEPTH; i++)
	       child_node.path[i] = node.path[i];
	    for (i=0; i<MAXOPS; i++)
		child_node.child_expanded[i] = 0;
	    if (child_node.level > 2)
	       node_count[oporder[mi]]++;
	    Insert(child_node, OPEN);
	 }
	           /* collect stats for rejected node with the lowest h value */
	 else if (child_node.h < lowest_heuristic) {
	    lowest_heuristic = child_node.h;
	    for (i=0; i<MAX_DEPTH; i++)
	       lowest_h_path[i] = node.path[i];
	    lowest_h_level = child_node.level;
	    lowest_cum_error = child_node.cum_heuristic_error;
	 }
      }
   }

   return(FALSE);
}


/* Dfs with local node ordering. */
int dfs2(neighbors)
   int neighbors[];
{
   Node node, child[MAXOPS];
   int i, j, b, ai, len, move, f_val, heuristic_error;

   while (!EmptyList(OPEN)) {
      rc = pvm_probe(-1, -1);                           /* check for messages */
      if (rc) {
         rc = pvm_bufinfo(rc, &len, &type, &source);
	 message = parse_message(type, source);
      }

      if (ListSize(OPEN) < anticipatory)    /* if list is too small, get work */
         get_work(2);

      node = RemoveFirst(OPEN);                   /* get parent node off list */

       /* move is based on where the blank is (b) and which move to make next */
      b = 0;                                   /* find location of blank cell */
      while (node.puzzle[b] != 0)
	 b++;

      ai = 0;                                        /* generate all children */
      for (i=0; i<MAXOPS; i++) {
	 move = children[b][oporder[i]];
	 if (move != node.parent && move != -1) {
	    for (j=0; j<16; j++)
	       child[ai].puzzle[j] = node.puzzle[j];
	    child[ai].puzzle[b] = child[ai].puzzle[move]; /* apply operator */
	    child[ai].puzzle[move] = 0;
	    child[ai].parent = b;
	    child[ai].level = node.level + 1;
	    child[ai].h = state_cost(child[ai].puzzle, goal);
	    child[ai].number_children = 0;
	    heuristic_error = child[ai].h - (root_heuristic - child[ai].level);
	    child[ai].cum_heuristic_error =
	       node.cum_heuristic_error + heuristic_error;
	                         /* if this is the goal, send message to host */
	    if ((child[ai].h == 0) && (child[ai].level < goal_level))
  	       goal_found(child[ai]);
	    f_val = child[ai].level + child[ai].h;
	    if (node.number_children == 0)
	       parents++;
	    node.number_children += 1;

	    if (f_val <= threshold) {       /* if f small enough, insert node */
	       for (j=0; j<MAX_DEPTH; j++)
	          child[ai].path[j] = node.path[j];
	       child[ai].path[node.level] = oporder[i];
	       for (j=0; j<MAXOPS; j++)
	          child[ai].child_expanded[j] = 0;
	       if (child[ai].level > 2)
	          node_count[oporder[i]]++;
	       ai++;
	    }
	           /* collect stats for rejected node with the lowest h value */
	    else if (child[ai].h < lowest_heuristic) {
	       lowest_heuristic = child[ai].h;
	       for (j=0; j<MAX_DEPTH; j++)
	          lowest_h_path[j] = node.path[j];
	       lowest_h_path[node.level] = oporder[i];
	       lowest_h_level = child[ai].level;
	       lowest_cum_error = child[ai].cum_heuristic_error;
	    }
	 }
      }
      isort(child, ai);
      if (ai > 0) {
         for (i=0; i<ai; i++) {
	    Insert(child[i], OPEN);
	    total_nodes++;
         }
      }
   }

   return(FALSE);
}


isort(child, n)
   Node child[MAXOPS];
   int n;
{
   int i, j;
   Node temp;

   for (i=1; i<n; i++) {
      temp = child[i];
      j = i - 1;
      while ((j >= 0) && (child[j].h < temp.h)) {
         child[j+1] = child[j];
	 j--;
      }
      child[j+1] = temp;
   }
}
