#include "eureka.h"


/* Note that Korf's order is D, R, L, U or 0, 1, 2, 3 */
int children[16][4] = {        /* Row = Tile next to blank, D, R, L, U */
  -1, -1, 1, 4,  -1, 0, 2, 5,     -1, 1, 3, 6,     -1, 2, -1, 7,
  0, -1, 5, 8,    1, 4, 6, 9,      2, 5, 7, 10,     3, 6, -1, 11,
  4, -1, 9, 12,   5, 8, 10, 13,    6, 9, 11, 14,    7, 10, -1, 15,
  8, -1, 13, -1,   9, 12, 14, -1,  10, 13, 15, -1,  11, 14, -1, -1};


List *MakeEmptyList(L)
   List *L;
{
   if (L == NULL) {
      L = (List *) malloc(sizeof(List));
      if (L == NULL) {
         fprintf(stderr, "Out of memory, can not allocate list\n");
	 exit(1);
      }
      L->Elements = (Node *) malloc(LISTINITSIZE * sizeof(Node));
      if (L->Elements == NULL) {
         fprintf(stderr, "Out of memory, can not allocate list elements\n");
	 exit(1);
      }
      L->MaxSize = LISTINITSIZE;
   }

   L->First = -1;
   L->Last = -1;
   return(L);
}


int EmptyList(L)
   List *L;
{
   return(L->First == L->Last);
}


void Insert(x, L)
   Node x;
   List *L;
{
   int i, last, size;

   L->First += 1;
   if ((L->First >= L->MaxSize) && (L->Last != -1)) {
      last = L->Last + 1;
      size = ListSize(L);
      for (i=0; i<size; i++)
	 L->Elements[i] = L->Elements[i+last];
      L->First -= last;
      L->Last = -1;
   }
   if (L->First >= L->MaxSize) {
      L->MaxSize += LISTINITSIZE;
      L->Elements = (Node *) realloc(L->Elements, L->MaxSize * sizeof(Node));
      if (L->Elements == NULL) {
         fprintf(stderr, "Out of memory\n");
	 exit(1);
      }
   }
   L->Elements[L->First] = x;
}


Node RemoveFirst(L)
   List *L;
{
   Node x;

   if (EmptyList(L)) {
      fprintf(stderr, "Error:  calling Remove with an empty list\n");
      exit(1);
   }

   x = L->Elements[L->First];
   L->First--;

   return(x);
}


Node RemoveLast(L)
   List *L;
{
   Node x;

   if (EmptyList(L)) {
      fprintf(stderr, "Error:  calling Remove with an empty list\n");
      exit(1);
   }

   x = L->Elements[L->Last + 1];
   L->Last++;

   return(x);
}


/* This copies a clean list (no removes have been made) to a new list */
List *RestoreList(source)
   List *source;
{
   int i, size;
   List *target = NULL;

   target = MakeEmptyList(target);
   size = ListSize(source);

   for (i=0; i<size; i++)
      target->Elements[i] = source->Elements[i];
   target->First = i-1;

   return(target);
}


int ListSize(L)
   List *L;
{
   return(L->First - L->Last);
}


int find_processor(id)
   int id;
{
   int i;

   for (i=0; i<numnodes; i++)
      if (tids[i] == id)
         return(i);

   return(-1);
}


print_puzzle(n)
   Node n;
{
   int i;

   for (i=0; i<16; i++)
      fprintf(stderr, "%d ", n.puzzle[i]);
   fprintf(stderr, "\n");
   fflush(stderr);
}
