#include "eureka.h"

typedef struct
{
   int     quot;		/* quotient */
   int     rem;			/* remainder */
}  my_div_t;

my_div_t my_div();

/*
 * *  div() *
 * 
 *  This function replaces the div function in the stlib library *  which is
 * not provided in this implementation of C.
 */

my_div_t my_div(num, denom)
   int     num;
   int     denom;
{
   my_div_t result;

   result.quot = (int) (num / denom);
   result.rem = num % denom;
   return(result);
}

/*
 * *  distance() - The Manhattan distance function *
 * 
 *  The sum of the row and column differences of the two puzzle board *
 * positions. This represents the minimum number of moves to move from *  one
 * position to another. This is exact if the empty spot lines up *  properly,
 * but is an underestimate if there are any detours or the *  empty spot does
 * not line up properly.
 */

distance(x, y, size)
   int x, y, size;
{
   my_div_t xdat, ydat;

   xdat = my_div(x, size);
   ydat = my_div(y, size);
   return(abs(xdat.quot - ydat.quot) + abs(xdat.rem - ydat.rem));
}


/*
 * *  state_cost() *
 * 
 *  Calculate the cost of moving each tile from it's current spot to the *
 * proper spot on the puzzle board. Care must be taken to avoid adding *  the
 * cost of moving the empty spot, because it moves as a side effect *  of
 * moving a tile.
 */

int state_cost(puzzle, goal)
   int puzzle[], goal[];
{
   int i, total;

   total = 0;

   /* get the puzzle space pointer from the search space */

   for (i=0; i<16; i++)
      if (puzzle[i] != 0)
	 total += distance(i, goal[puzzle[i]], 4);

   return(total);
}
