#include "eureka.h"


int host, mytid, halt_processing, cluster_root, cluster_size, size_neighborhood;
int me, pvm_exit_program, dest_of_last_request, neighbors[MAX_PROCESSORS];
time_t goal_finish_time;
List *InitList = NULL;

char *print_message(msg)
   int msg;
{
   switch(msg) {
      case 0:   return("PUZZLE_COMING");
      case 1:   return("GOAL_COMING");
      case 2:   return("THRESHOLD_COMING");
      case 3:   return("NODE_REQUEST");
      case 4:   return("LOAD_BAL_SWITCH_COMING");
      case 5:   return("ORDERING_SWITCH_COMING");
      case 6:   return("REJECT");
      case 7:   return("GOAL_INFO");
      case 8:   return("OPORDER_COMING");
      case 9:   return("HALT_PROCESSING");
      case 10:  return("NO_MESSAGE");
      case 11:  return("BUSY");
      case 12:  return("IDLE");
      case 13:  return("EUREKA");
      case 14:  return("GIVEAWAY_SWITCH_COMING");
      case 15:  return("ALPHA_COMING");
      case 16:  return("GOFORIT");
      case 17:  return("CLUSTER_ROOT");
      case 18:  return("CLUSTER_SIZE");
      case 19:  return("SEND_GOAL_INFO");
      case 20:  return("ANTICIPATORY_SWITCH_COMING");
      case 21:  return("GOAL_LEVEL_COMING");
      case 22:  return("STATS_COMING");
      case 23:  return("NODE_INFO");
      case 24:  return("LOWEST_HEURISTIC_COMING");
      case 25:  return("MOVING_ON");
   }
}


/* process incoming messages */
int parse_message(msg, source)
   int msg, source;
{
   int i, send_this_many, priority;
   Node node;

   /*fprintf(stderr, "In parse_message, message is %s\n", print_message(msg));
   fflush(stderr);*/
   pvm_recv(source, msg);

   switch(msg) {
      case ALPHA_COMING:
	 pvm_upkfloat(&alpha, 1, 1);
         break;

      case ANTICIPATORY_SWITCH_COMING:
	 pvm_upkint(&anticipatory, 1, 1);
         break;

      case CLUSTER_ROOT:
	 pvm_upkint(&cluster_root, 1, 1);
         break;

      case CLUSTER_SIZE:
	 pvm_upkint(&cluster_size, 1, 1);
         size_neighborhood = get_neighbors();        /* who are my neighbors? */
         break;

      case GIVEAWAY_SWITCH_COMING:
	 pvm_upkint(&giveaway, 1, 1);
         break;

      case GOAL_COMING:
	 pvm_upkint(goal, 16, 1);
         break;

      case GOAL_LEVEL_COMING:
         pvm_upkint(&goal_level, 1, 1);
	 break;

      case GOFORIT:
         break;

      case HALT_PROCESSING:
         halt_processing = TRUE;
         break;

      case LOAD_BAL_SWITCH_COMING:
         pvm_upkint(&load_balancing, 1, 1);
         break;

      case NODE_REQUEST:
         pvm_upkint(&priority, 1, 1);
	 i = ListSize(OPEN);            /* determine how many nodes to donate */
	 if (i > JOBTHRESHOLD)
	    send_this_many = (int) (i * alpha);
	 else send_this_many = 0;
	 if (priority == 2 && send_this_many >= 3)
	    send_this_many = 3;
	 pvm_initsend(PvmDataDefault);
	 if (send_this_many > 0) {        /* send information about each node */
	    pvm_pkint(&send_this_many, 1, 1);
	    for (i=0; i<send_this_many; i++) {
	       if (giveaway == TOP)
	          node = RemoveFirst(OPEN);
	       else node = RemoveLast(OPEN);
	       pvm_pkint(&node.parent, 1, 1);
	       pvm_pkint(&node.level, 1, 1);
	       pvm_pkint(node.child_expanded, MAXOPS, 1);
	       pvm_pkint(node.puzzle, 16, 1);
	       pvm_pkint(node.path, node.level+1, 1);
	       pvm_pkint(&node.number_children, 1, 1);
	       pvm_pkint(&node.h, 1, 1);
	       pvm_pkint(&node.cum_heuristic_error, 1, 1);
	    }
	    pvm_send(source, PUZZLE_COMING);                  /* donate nodes */
	 }
	 else pvm_send(source, REJECT);            /* reject request for work */
         break;

      case NODE_INFO:
         pvm_upkint(&numnodes, 1, 1);
	 pvm_upkint(tids, numnodes, 1);
         me = find_processor(mytid);
         fprintf(stderr, "I, (%d %d), am here\n", me, mytid);
         break;

      case OPORDER_COMING:
         pvm_upkint(oporder, MAXOPS, 1);
         break;

      case ORDERING_SWITCH_COMING:
         pvm_upkint(&ordering, 1, 1);
         break;

      case PUZZLE_COMING:
         waiting_on_request = FALSE;
	 process_incoming_node(source);
	 if (busy_message_sent == FALSE) {
	    pvm_initsend(PvmDataDefault); /* tell host this processor is busy */
	    pvm_send(host, BUSY);
	    busy_message_sent = TRUE;
	 }
	 idle_message_sent = FALSE;
	 number_of_rejects = 0;
         break;

      case REJECT:
         if (source == dest_of_last_request)
	    waiting_on_request = FALSE;
	 number_of_rejects++;
	                                  /* neither neighbor can donate work */
	 if ((number_of_rejects == size_neighborhood) &&
	     (idle_message_sent == FALSE)) {
	    pvm_initsend(PvmDataDefault); /* tell host this processor is idle */
	    pvm_send(host, IDLE);
	    idle_message_sent = TRUE;
	    busy_message_sent = FALSE;
	 }

	 if (((number_of_rejects % size_neighborhood) == 0) &&
	     (ListSize(OPEN) == 0))
	    sleep(WAITTIME);                      /* Wait before asking again */
         break;

      case SEND_GOAL_INFO:
	 pvm_initsend(PvmDataDefault);       /* send goal information to host */
	 pvm_pkint(&goal_level, 1, 1);
	 pvm_pkint(goal_oporder, MAXOPS, 1);
	 pvm_pkint(&total_nodes, 1, 1);
	 pvm_pkint(goal_path, goal_level, 1);
	 pvm_pklong(&goal_finish_time, 1, 1);
	 pvm_send(host, GOAL_INFO);
         break;

      case THRESHOLD_COMING:
         pvm_upkint(&threshold, 1, 1);
	 if (root_heuristic == -1)
	    root_heuristic = threshold;
         break;

      default:
         fprintf(stderr, "A message of type %s was sent from processor %d\n",
	                 print_message(msg), source);
         pvm_recv(source, type);
   }

   return(msg);
}


process_incoming_node(source)
   int source;
{
   int i, j, n;
   Node node;

   pvm_upkint(&n, 1, 1);      /* number of incoming nodes */

   for (i=0; i<n; i++) {
      pvm_upkint(&node.parent, 1, 1);
      pvm_upkint(&node.level, 1, 1);
      pvm_upkint(node.child_expanded, MAXOPS, 1);
      pvm_upkint(node.puzzle, 16, 1);
      pvm_upkint(node.path, node.level+1, 1);
      pvm_upkint(&node.number_children, 1, 1);
      pvm_upkint(&node.h, 1, 1);
      pvm_upkint(&node.cum_heuristic_error, 1, 1);
      Insert(node, OPEN);
      if (source == host)
         Insert(node, InitList);
   }
}


main(argc, argv)
   int argc;
   char *argv[];
{
   int rc, len;

   InitSearch();

   while (pvm_exit_program == FALSE) {          /* process until told to exit */
      message = NO_MESSAGE;
      while (message != GOFORIT) {              /* wait for a GOFORIT message */
	 rc = pvm_probe(host, -1);
	 if (rc) {
	    rc = pvm_bufinfo(rc, &len, &type, &source);
	    message = parse_message(type, source);
	 }
      }

      waiting_on_request = idle_message_sent = busy_message_sent = FALSE;
      halt_processing = FALSE;
      number_of_rejects = lowest_h_level = 0;
      lowest_heuristic = lowest_cum_error = 9999;

      while (!halt_processing) {                               /* search loop */
         if (EmptyList(OPEN)) {             /* try to get work from neighbors */
	    if (load_balancing == ASYNC) {
	       threshold += THRESHOLD_INCREMENT;
	       NewPass(0);             /* reset variables for new search pass */
	       pvm_initsend(PvmDataDefault);
	       pvm_pkint(&threshold, 1, 1);
	       pvm_send(host, MOVING_ON);
	    }
	    else get_work(1);
	 }
	 else {                              /* have work, perform DFS search */
	    if (ordering == LOCAL)
	       dfs2(neighbors);
	    else dfs1(neighbors);
	 }

	 rc = pvm_probe(-1, -1);                        /* check for messages */
	 if (rc) {
	    rc = pvm_bufinfo(rc, &len, &type, &source);
	    message = parse_message(type, source);
	 }

             /* if no load balancing, inform host that this processor is idle */
	 if (load_balancing == OFF && idle_message_sent == FALSE) {
	    pvm_initsend(PvmDataDefault);
	    pvm_send(host, IDLE);
	    idle_message_sent = TRUE;
	    busy_message_sent = FALSE;
	 }
      }

      NewPass(1);                      /* reset variables for new search pass */
      pvm_initsend(PvmDataDefault);          /* inform host that we are ready */
      pvm_send(host, GOFORIT);
   }

   pvm_exit();
}


InitSearch()
{
   int i;

   mytid = pvm_mytid();                                      /* enroll in pvm */
   host = pvm_parent();

   srand(time(NULL) + mytid);
   goal_level = 999;
   root_heuristic = -1;
   total_nodes = parents = 1;

   OPEN = NULL;
   OPEN = MakeEmptyList(OPEN);
   InitList = MakeEmptyList(InitList);

   for (i=0; i<MAX_DEPTH; i++)
      lowest_h_path[i] = -1;
}


int set_oporder()
{
   int i, temp, current=0;
   int used[MAXOPS] = {FALSE, FALSE, FALSE, FALSE};

   for (i=0; i<lowest_h_level; i++) {
      if (used[lowest_h_path[i]] == FALSE) {
         temp = lowest_h_path[i];
         used[temp] = TRUE;
         oporder[current++] = temp;
      }
      if (current >= MAXOPS)
         return(1);
   }

   for (i=0; i<MAXOPS; i++)
      if (used[i] == FALSE)
         oporder[current++] = i;

   return(1);
}


/* Clear messages if necessary and reset variables for new search pass. */
NewPass(clearm)
   int clearm;
{
   int i, rc;

   if (clearm) {                             /* clear all messages */
      rc = pvm_probe(-1, -1);
      while (rc) {
         pvm_recv(-1, -1);
	 rc = pvm_probe(-1, -1);
      }
   }

   if (OPEN != NULL) {
      if (OPEN->Elements != NULL)
         free(OPEN->Elements);
      free(OPEN);
   }
   OPEN = RestoreList(InitList);          /* restore list to original subtree */
   if (ordering == TOIDA) /* if operator ordering on, set next operator order */
      rc = set_oporder();

   pvm_initsend(PvmDataDefault);      /* send lowest h and new operator order */
   pvm_pkint(&lowest_heuristic, 1, 1);
   pvm_pkint(oporder, MAXOPS, 1);
   pvm_send(host, LOWEST_HEURISTIC_COMING);

                  /* calculate and send statistics for this iteration to host */
   pvm_initsend(PvmDataDefault);
   if (lowest_h_level != 0)
      avg_herror = (float) lowest_cum_error / lowest_h_level;
   else avg_herror = 0.00;
   pvm_pkint(&total_nodes, 1, 1);
   pvm_pkint(&parents, 1, 1);
   pvm_pkint(node_count, MAXOPS, 1);
   pvm_pkint(&lowest_h_path[0], 1, 1);
   pvm_pkfloat(&avg_herror, 1, 1);
   pvm_send(host, STATS_COMING);

                     /* initialize variables used during an iteration of ida* */
   busy_message_sent = idle_message_sent = FALSE;

                            /* set node counts back to zero for new iteration */
   for (i=0; i<MAXOPS; i++)
      node_count[i] = 0;
   total_nodes = parents = 0;
}


int get_neighbors()
{
   int root;

   if (cluster_size == 1)              /* no other processors in this cluster */
      return(0);

   if (cluster_size == 2) {            /* one other processor in this cluster */
      if (me == cluster_root)
         neighbors[0] = tids[me + 1];
      else neighbors[0] = tids[me - 1];
      return(1);
   }

          /* neighbors are processor before and after this one in the cluster */
   if (me == cluster_root)
      neighbors[0] = tids[cluster_root + cluster_size - 1];
   else neighbors[0] = tids[me - 1];
   if ((me + 1) >= (cluster_root + cluster_size))
      neighbors[1] = tids[cluster_root];
   else neighbors[1] = tids[me + 1];
   dest_of_last_request = neighbors[1];

   return(2);
}


int goal_found(node)
   Node node;
{
   int i;

   fprintf(stderr, "%3d: Goal found at level %d\n", me, node.level);
   message = node.level;
   pvm_initsend(PvmDataDefault);
   pvm_pkint(&node.level, 1, 1);
   pvm_send(host, EUREKA);
   fprintf(stderr, "I (%d %d) sent EUREKA\n", me, mytid); fflush(stderr);

   if (node.level < goal_level) {
      goal_level = node.level;
      for (i=0; i<MAXOPS; i++)
         goal_oporder[i] = oporder[i];
      for (i=0; i<node.level; i++)
        goal_path[i] = node.path[i];
      goal_finish_time = time((time_t *) 0);
   }
   return(TRUE);
}


/* Send work request to neighbor, make sure we are not waiting on a previous
   work request. */
get_work(priority)
   int priority;
{
   if ((waiting_on_request == TRUE) || (load_balancing == OFF) ||
       (size_neighborhood == 0))
      return;

   waiting_on_request = TRUE;
   pvm_initsend(PvmDataDefault);                     /* ask neighbor for work */
   pvm_pkint(&priority, 1, 1);
   if (load_balancing == NEIGHBOR) {
      if (size_neighborhood == 1)
         dest_of_last_request = neighbors[0];
      else if (dest_of_last_request == neighbors[1])
         dest_of_last_request = neighbors[0];
      else dest_of_last_request = neighbors[1];
   }
   else if (load_balancing == RANDOM)
      dest_of_last_request = tids[rand() % numnodes];
   pvm_send(dest_of_last_request, NODE_REQUEST);
}
